Rygel.MediaServerPlugin – librygel-server Reference Manual

# MediaServerPlugin

## Object Hierarchy:

## Description:

public abstract class MediaServerPlugin : Plugin

This is the base class for every Rygel implementation of a UPnP media server. It should be used either for a real plug-in for the Rygel process or used in-process via the librygel-server API.

The plugin instance should have a #RygelMediaContainer instance as its root container, which may be provided to the constructor.

See the <link linkend="implementing-server-plugins">Implementing Server Plugins</link> section.

Namespace: Rygel
Package: librygel-server

## Content:

### Properties:

- public MediaContainer root_container { construct; get; }
- public virtual string search_caps { get; }
  The SearchCapabilities this MediaServer plugin supports.
- public unowned List<DLNAProfile> upload_profiles { construct set; get; }
  The list of DLNA profiles the MediaServer in this plugin will accept files as upload.
- public unowned List<DLNAProfile> supported_profiles { construct set; get; }
  The list of DLNA profiles the MediaServer in this plugin will be able to serve.

### Creation methods:

- public MediaServerPlugin (MediaContainer root_container, string name, string? description = null, PluginCapabilities capabilities = NONE)
  Create an instance of the plugin. The plugin's service will have the same title as its root container.

### Methods:

- public override void constructed ()
- public override void apply_hacks (RootDevice device, string description_path) throws Error

### Inherited Members:

All known members inherited from class Rygel.Plugin

- active
- capabilities
- default_icons
- desc_path
- description

- icon_infos
- name
- resource_infos
- title

- add_icon
- add_resource
- apply_hacks
- constructed

All known members inherited from class GUPnP.ResourceFactory

- get_default
- register_resource_proxy_type

- register_resource_type
- unregister_resource_proxy_type

- unregister_resource_type

All known members inherited from class GLib.Object

- interface_find_property
- interface_install_property
- interface_list_properties
- @new
- new_valist
- newv
- new_with_properties
- add_toggle_ref
- add_weak_pointer
- bind_property
- connect
- constructed
- disconnect
- dispose
- dup_data
- dup_qdata
- force_floating

- freeze_notify
- @get
- get_class
- get_data
- get_property
- get_qdata
- get_type
- getv
- is_floating
- notify_property
- @ref
- ref_sink
- replace_data
- replace_qdata
- remove_toggle_ref
- remove_weak_pointer
- @set

- set_data
- set_data_full
- set_property
- set_qdata
- set_qdata_full
- set_valist
- setv
- steal_data
- steal_qdata
- thaw_notify
- unref
- watch_closure
- weak_ref
- weak_unref
- notify
- ref_count